SystemOrganization addCategory: #'PLP-TP3'!

Object subclass: #Arreglador
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!Arreglador class methodsFor: 'as yet unclassified' stamp: 'ManuelGimenez 10/29/2013 23:03'!
arreglar
	"Debe modificar la implementacion para reflejar complacer el ultimo capricho del arquitecto"
	self notYetImplemented .! !

Object subclass: #Transformador
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

Transformador subclass: #TransIdentidad
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransIdentidad methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 11/11/2013 15:38'!
transformar: unObjeto
	^unObjeto.! !

Transformador subclass: #TransString
	instanceVariableNames: 'from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

TransString subclass: #TransCaracter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransString class methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 11/11/2013 16:12'!
newWith:from and:to 

	|instance|
	
	instance := self new.
	^instance initializeWith:from and:to.! !

!TransString methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 11/11/2013 16:10'!
initializeWith:fromNew and:toNew
	
	from := fromNew.
	toNew := toNew.
	! !

!TransString methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 11/11/2013 16:00'!
transformar:unString 

	^ unString copyWithRegex: from matchesReplacedWith: to.

	
	! !

TransString subclass: #TransSubstring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!Transformador methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 11/11/2013 03:50'!
comoListaEquivalente

	self notYetImplemented .! !

!Transformador methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 11/11/2013 15:38'!
transformar: unObjeto
	self subclassResponsibility  .! !

TestCase subclass: #TransformadorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransformadorTest methodsFor: 'testsBasicos' stamp: 'ManuelGimenez 10/30/2013 00:39'!
testTransBloque

	| trans5 unBloque unaColeccionOrdenada |
	trans5 := self transformador5 .
	unaColeccionOrdenada := OrderedCollection new.
	unBloque := [ unaColeccionOrdenada add: 0 ].
	
	(trans5 transformar: unBloque) value.
	self assert: ( unaColeccionOrdenada size = 3 ).! !

!TransformadorTest methodsFor: 'testsBasicos' stamp: 'ManuelGimenez 11/5/2013 00:01'!
testTransCaracter

	| trans2 trans3 |
	trans2 := self transformador2 .
	trans3 := self transformador3 .
	
	self assert: ( (trans2 transformar: 'patoloco') = 'pbtoloco' ).
	self assert: ( (trans2 transformar: 'monoloco') = 'monoloco' ).
	self assert: ( (trans3 transformar: 'elosodebimbo') = 'elosodeaimao' ).
	self assert: ( (trans3 transformar: 'patoloco') = 'patoloco' ).
! !

!TransformadorTest methodsFor: 'testsCompuestos' stamp: 'ManuelGimenez 11/5/2013 00:02'!
testTransCondicion

	| trans8 trans9 
	unStringImpar otroStringImpar unStringPar otroStringPar 
	unBloquePar unBloqueImpar unaColeccionOrdenada unNuevoBloque |
	
	trans8 := self transformador8 .
	trans9 := self transformador9 .
	
	unStringImpar := 'bab'.
	unStringPar := 'aa'.
	otroStringImpar := 'aaa'.
	otroStringPar := 'bb'.
	
	self assert: ( (trans8 transformar: unStringPar) = 'bb' ).
	self assert: ( (trans8 transformar: unStringImpar) = 'aaa' ).
	self assert: ( (trans8 transformar: otroStringPar) = otroStringPar ).
	self assert: ( (trans8 transformar: otroStringImpar ) = otroStringImpar ).
	
	unaColeccionOrdenada := OrderedCollection new.
	unBloquePar := [ unaColeccionOrdenada add:0. ^4 ].
	unBloqueImpar := [ unaColeccionOrdenada add:0. ^3 ].
	
	unNuevoBloque := trans9 transformar: unBloquePar.
	unaColeccionOrdenada := OrderedCollection new.
	unNuevoBloque value.
	self assert: (unaColeccionOrdenada size = 3).
	
	unNuevoBloque := trans9 transformar: unBloqueImpar.
	unaColeccionOrdenada := OrderedCollection new.
	unNuevoBloque value.
	self assert: (unaColeccionOrdenada size = 1).! !

!TransformadorTest methodsFor: 'testsBasicos' stamp: 'ManuelGimenez 10/30/2013 00:04'!
testTransIdentidad

| unTransformadorIdentidad |
unTransformadorIdentidad := self transformador1 .
self assert: ( unTransformadorIdentidad transformar: self == self ).! !

!TransformadorTest methodsFor: 'testsCompuestos' stamp: 'ManuelGimenez 11/5/2013 00:01'!
testTransSecuencial

	| trans6 trans7 |
	trans6 := self transformador6 .
	trans7 := self transformador7 .
	
	self assert: ( (trans6 transformar: 'patoloco') = 'patoloco' ).
	self assert: ( (trans6 transformar: 'monoloco') = 'monoloco' ).
	self assert: ( (trans6 transformar: 'elosodebimbo') = 'elosodeaimao' ).
	self assert: ( (trans7 transformar: 'patoloco') = 'pbtoloco' ).
	self assert: ( (trans7 transformar: 'monoloco') = 'monoloco' ).! !

!TransformadorTest methodsFor: 'testsBasicos' stamp: 'ManuelGimenez 10/30/2013 00:22'!
testTransSubstring

	| trans4 |
	trans4 := self transformador4 .
	
	self assert: ( (trans4 transformar: 'monoloco') = 'monoloco' ).
	self assert: ( (trans4 transformar: 'buu') = 'md' ).
	self assert: ( (trans4 transformar: 'monobuuloco') = 'monomdloco' ).! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'MartinCarreiro 11/11/2013 16:07'!
transformador1
	"Debe retornar el transformador especificado en el enunciado"
	^TransIdentidad new.! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'MartinCarreiro 11/11/2013 16:13'!
transformador2
	"Debe retornar el transformador especificado en el enunciado"
	^TransCaracter newWith:'a' and:'b'! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'MartinCarreiro 11/11/2013 16:13'!
transformador3
	"Debe retornar el transformador especificado en el enunciado"
	^TransCaracter newWith:'b' and:'a'! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'ManuelGimenez 10/30/2013 00:12'!
transformador4
	"Debe retornar el transformador especificado en el enunciado"
	self notYetImplemented .! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'ManuelGimenez 10/30/2013 00:12'!
transformador5
	"Debe retornar el transformador especificado en el enunciado"
	self notYetImplemented .! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'ManuelGimenez 10/30/2013 00:12'!
transformador6
	"Debe retornar el transformador especificado en el enunciado"
	self notYetImplemented .! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'ManuelGimenez 10/30/2013 00:12'!
transformador7
	"Debe retornar el transformador especificado en el enunciado"
	self notYetImplemented .! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'ManuelGimenez 10/30/2013 00:12'!
transformador8
	"Debe retornar el transformador especificado en el enunciado"
	self notYetImplemented .! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'ManuelGimenez 10/30/2013 00:12'!
transformador9
	"Debe retornar el transformador especificado en el enunciado"
	self notYetImplemented .! !
